import axios from 'axios'
import qs from 'qs'

//字数超出限制、token失效\无token情况

//axios.defaults.baseURL =  'https://logic.test.uqchat.cn/logic';   //配置接口地址-测试
//axios.defaults.baseURL =  'http://192.168.2.92:8080/logic';   //配置接口地址-测试
//切换环境index.vue需要更改地址
axios.defaults.baseURL =  'https://logic.uqchat.cn/logic';   //配置接口地址-生产
axios.defaults.timeout = 5000;  //响应时间
axios.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded;charset=UTF-8';  //配置请求头

//添加请求拦截器，在请求头中加token
axios.interceptors.request.use((config) => {
    if (localStorage.getItem('Authorization')) {
        config.headers.common["My-Token"] = localStorage.getItem('Authorization');
    }
    if (localStorage.getItem('DeviceToken')) {
        config.headers.common["DeviceToken"] = localStorage.getItem('DeviceToken');
    }
    if (localStorage.getItem('MyUserAgent')) {
        config.headers.common["My-User-Agent"] = localStorage.getItem('MyUserAgent');
    }
    return config;
},(error) =>{
    return Promise.reject(error);
});
//POST传参序列化(添加请求拦截器)
axios.interceptors.request.use((config) => {
    if(config.method  === 'post'){
        config.data = qs.stringify(config.data);
    }
    return config;
},(error) =>{
    console.log('错误的传参')
    return Promise.reject(error);
});

//返回状态判断(添加响应拦截器)
axios.interceptors.response.use((res) =>{
    //对响应数据做些事
    if(!res.data.success){
        return Promise.resolve(res);
    }
    return res;
}, (error) => {
    console.log('网络异常')
    return Promise.reject(error);
});

export default {
    //返回一个Promise(发送post请求)
    fetchPost(url, params) {
        return new Promise((resolve, reject) => {
            axios.post(url, params)
                .then(response => {
                    resolve(response);
                }, err => {
                    reject(err);
                })
                .catch((error) => {
                    reject(error)
                })
        })
    },
    //返回一个Promise(发送get请求)
    fetchGet(url, param) {
        return new Promise((resolve, reject) => {
            axios.get(url, {params: param})
                .then(response => {
                    resolve(response)
                }, err => {
                    reject(err)
                })
                .catch((error) => {
                    reject(error)
                })
        })
    },
    //获取URL参数
    getUrlKey (name) {
        return decodeURIComponent((new RegExp('[?|&]' + name + '=' + '([^&;]+?)(&|#|;|$)').exec(location.href) || [, ""])[1].replace(/\+/g, '%20')) || null
    }   
}